
//***************************************************************
//*  SVGAdem2.c  - Smooth scrolling + transparency effect
//*  (WATCOM C 10.5 + WASM ) (sorry for sparse comments & unsophisticated English) 
//***************************************************************

         #include <stdio.h>
         #include <stdlib.h>
         #include <mem.h>
         #include <math.h> 
         #include <dos.h>
         #include <string.h>
         #include <stdlib.h>
         #include <malloc.h>
         #include <direct.h>    
         #include <bios.h>
         #include <conio.h> 

//***************************************************************
//* Type definitions and defines
//***************************************************************

         typedef signed short   WORD;
         typedef unsigned char  UBYTE;
         typedef unsigned short UWORD;
         typedef unsigned long  ULONG;

         #define  VScreenWidth 768
         #define  VScreenHeight 640
         #define  TileWidth   128
         #define  TileHeight  128
         #define  MaskWidth   256
         #define  MaskHeight  256
         #define  VScreenSize VScreenWidth*VScreenHeight
         #define  TileSize    TileWidth*TileHeight
         #define  MaskSize    MaskWidth*MaskHeight
//  Functions
       
         void SetVMode(UWORD mode);                      
         UWORD SetSVGA ();                       
         UWORD CheckSVGA ();        
         void ClearSVGA (UBYTE color);           
         void SetPage (UBYTE page);
         void LoadBINBitmap(char *filename,UBYTE *buffer,ULONG size);
         void SetPalette(UBYTE *palette);
         void PrepareVScreen(UBYTE *tile,UBYTE *screen_buffer);

// WASM - external functions      
         extern void near  AddBlit(UBYTE *screen_buffor,UBYTE *mask_buffer);
         #pragma aux AddBlit "*_" parm caller [edi] [esi];
         extern void near  SubBlit(UBYTE *screen_buffor);
         #pragma aux SubBlit "*_" parm caller [edi] ;
         extern void near BlitMemVram(UBYTE *data,UWORD x,UWORD y,UWORD width,
                                      UWORD height);
         #pragma aux BlitMemVram "*_" parm caller [esi] [ebx] [eax] [ecx] [edi] ;
                      
      
//****************************************************************
// Global variables
//****************************************************************
         
           
         UWORD Addgran=0;                // page granularity
         UWORD Curwind=0;                // current page #

//****************************************************************
//****************************************************************


     void main()
        {
          
         char *fname = "tile.bin";   //  bitmaps 
         char *fname2= "demo.mas";
         char *cname = "demo.pal";    // palette           
         UBYTE *tile_buffer;
         UBYTE *mask_buffer;
         UBYTE *screen_buffer;
         UBYTE palette[768];
         int frames=0;
         int i;
         ULONG time_start,time_end;
         UWORD fps10;
         
// allocate memory
   
         screen_buffer=malloc(VScreenSize+TileSize+MaskSize);         
         if(!screen_buffer)
         { printf("Error: Not enough memory");
          return;
         }
// initialize pointers
         tile_buffer=screen_buffer+(VScreenSize);
         mask_buffer=tile_buffer+(TileSize);
         
// load bitmaps and palette ( no error checking )
        
         LoadBINBitmap(fname,tile_buffer,TileSize);
         LoadBINBitmap(fname2,mask_buffer,MaskSize);
         LoadBINBitmap(cname,&palette,768);
// look for VESA BIOS

         if (CheckSVGA())
          return ;
// set mode 640x480x256
         fflush(stdout);
         delay (600);
         SetSVGA();
         ClearSVGA(120);         
// initialize palette
        
         SetPalette(&palette);
// prepare virtual screen         
         PrepareVScreen(tile_buffer,screen_buffer);
         
// main loop         
         frames=0;  
         _bios_timeofday(_TIME_GETCLOCK,&time_start);   // get DOS ticks
           
  
         while ( 1 )
         {
          if ( kbhit() )
          break;
          
          for (i=0;i<TileWidth;i+=2)
          {
// add transparent windows to the virtual screen            
           AddBlit(screen_buffer+(i+340)+(VScreenWidth*(i+150)),mask_buffer);           
           AddBlit(screen_buffer+(i+40)+(VScreenWidth*(i+50)),mask_buffer);
// display the virtual screen                              
           BlitMemVram(screen_buffer+i+(VScreenWidth*i),0,40,640,400);
// restore contents of the virtual screen           
           SubBlit(screen_buffer+(i+340)+(VScreenWidth*(i+150)));
           SubBlit(screen_buffer+(i+40)+(VScreenWidth*(i+50)));            
                       
           frames++;                                    // count frames
          }
          
          
         }
    
         _bios_timeofday(_TIME_GETCLOCK,&time_end);     // get DOS ticks again  
// free buffer and restore text mode 3
                  
         free(screen_buffer);                           
         SetVMode(3);
// compute average FPS and display it
         
         fps10=frames*182/(time_end-time_start);                              
         printf("Frame rate: %i.%i fps\n", fps10/10,fps10%10);
  
         return;
        }



//**************************************************************
//  SetPalette - Sets DAC                                      *
//**************************************************************

        void    SetPalette(UBYTE *palette)
        {
         UWORD   i;
         UBYTE *p;
            
         p=palette;
         outp(0x3c6,0xff);
         for(i=0;i<=255;i++)
         {
          outp(0x3c8,(UBYTE)i);
          outp(0x3c9,*p++);
          outp(0x3c9,*p++);
          outp(0x3c9,*p++);
         }            
         return ;
        }
//**************************************************************
//  LoadBINBitmap - loads bitmap (bin)                         *
//**************************************************************

        void LoadBINBitmap(char *filename,UBYTE *buffer,ULONG size)
        { 
         FILE *fp;

         fp=fopen (filename,"rb");
         if(!fp)
         {
          return;
         }
         fread(buffer,1,size,fp);
         fclose(fp);
       
         return;
        }

        
//**************************************************************
//  SetVMode - sets screen mode (VGA only)                     *
//**************************************************************
      
        void SetVMode (UWORD mode)
        {          
         union REGS regs;
         regs.w.ax=mode;
         int386 (0x10,&regs,&regs);          
         return;
        }


//*********************************************************************                          
//  CheckSVGA - checks for SVGA 640x480 VESA mode, error=1 if not found 
//*********************************************************************
      
        UWORD CheckSVGA()
        
        {
         static struct rminfo
         {        
          long EDI;
          long ESI;
          long EBP;
          long reserved_by_system;
          long EBX;
          long EDX;
          long ECX;
          long EAX;
          short flags;
          short ES,DS,FS,GS,IP,CS,SP,SS;
         } RMI;

     
         union  REGS regs;
         struct SREGS sregs;
         
         short selector;
         char  far *point;              
         short segment;
         UWORD error=0;
         
// DPMI call 100h allocates DOS memory for SVGA info buffer

         memset(&sregs,0,sizeof(sregs));
         regs.w.ax=0x0100;
         regs.w.bx=0x0010;                 
         int386x( 0x31, &regs, &regs, &sregs);
         segment=regs.w.ax;
         selector=regs.w.dx;

         point=MK_FP(selector,0);
               

// call VESA service 4F00 - return SVGA information

         memset(&RMI,0,sizeof(RMI));
         RMI.EAX=0x00004f00;              // service #
         RMI.ES=segment;                  // segment 
         RMI.EDI=0;                       // offset
  
         regs.w.ax = 0x0300;              
         regs.h.bl = 0x10;
         regs.h.bh = 0;
         regs.w.cx = 0;
         sregs.es = FP_SEG(&RMI);
         regs.x.edi = FP_OFF(&RMI);
         int386x( 0x31, &regs, &regs, &sregs );     // use DMPI to isue DOS INT

         printf ("\n==========================\n");
                   
// IF not succesful - print message and exit
        
         if (!(RMI.EAX==0x004f))
         {                      
          printf("ERROR : VESA BIOS not installed" );
          error=1;             
          goto L1;
         }
         
// ELSE print information about SVGA
            
         else
         {         
          printf ("Vesa bios found :version %c.%c",(*(point+5))+48,(*(point+4))+48);
          printf ("\n%d Kb video ram",(*(point+18))*64);
         }                  
         
// call VESA service 4F01 - return mode information

         memset(&RMI,0,sizeof(RMI));
         RMI.EAX=0x00004f01;              
         RMI.ES=segment;
         RMI.EDI=0;                       
         RMI.ECX=0x00000101;                
  
         regs.w.ax = 0x0300;              
         regs.h.bl = 0x10;
         regs.h.bh = 0;
         regs.w.cx = 0;
         sregs.es = FP_SEG(&RMI);
         regs.x.edi = FP_OFF(&RMI);
         int386x( 0x31, &regs, &regs, &sregs );          

         if (!(RMI.EAX==0x004f))
         {                      
          printf("\nERROR : Mode 640x480x8 not supported" );
          error=1;  
          goto L1;
         }            
         else
         {                  
          printf("\nMode 640x480x8 supported");            
          Addgran=64/(*(point+4));
          printf("\nWindow granularity =%d Kb",*(point+4));         
         }
         
// DPMI call 100h deallocates DOS memory used by SVGA info buffer

  L1:;
         regs.w.ax=0x0101;
         regs.w.dx=selector; 
         int386( 0x31, &regs, &regs);
                      
         return(error); 
        }

//*************************************************************                          
//  SetSVGA - sets 640x480 SVGA mode                          * 
//*************************************************************

         UWORD SetSVGA ()              
        {
      
         union REGS regs;
         
         regs.w.ax=0x4f02;
         regs.w.bx=0x101;    
         int386( 0x10, &regs, &regs);

         if (!(regs.w.ax==0x004f))
          {                      
             return (1);
          }         

         SetPage (0);    
         return(0);   
          
        }

//*************************************************************                          
//  ClearSVGA - clears (fills) screen                         * 
//*************************************************************        
        
        void   ClearSvga (UBYTE color)        
        {
         UBYTE j;
          
         for (j=0; j<4; j++)
         {   
          SetPage(j);
          memset(0xA0000,color,65536);
         }              
         SetPage(4);
         memset (0xA0000,color,45056);
            
         return ;
        }

//*************************************************************                          
//  SetPage - sets page using VESA BIOS call                  * 
//*************************************************************        
        
        void   SetPage (UBYTE page)        
        {
         union REGS regs;

         Curwind=page;  
         page=Addgran*page;                // page#=granularity * page# 
         regs.w.ax=0x4f05;
         regs.w.bx=0x000;                
         regs.h.dl=page;                  
         int386( 0x10, &regs, &regs);      
            
         return;
        }
//**************************************************************
//  Prepare VScreen - virtual screen gets filled with the tiles*
//**************************************************************

        void PrepareVScreen(UBYTE *tile,UBYTE *screen_buffer)
        { 
         int  i,j,k,l;
         

                 
         for (k=0;k<5;k++)
         {
           for  (j=0;j<TileHeight;j++)
           {
             for  (i=0;i<6;i++)
             {
               for (l=0;l<TileWidth;l++)
               {
                *((screen_buffer+l)+(i<<7)+(j*VScreenWidth)+(k*98304))=*((tile+l)+(j<<7));
               }               
             }                   
           }
         }
       
         return;
        }





